//----------------------------------------------------------------------------
// ObjectWindows
// Copyright (c) 1991, 1995 by Borland International, All Rights Reserved
//----------------------------------------------------------------------------
#include "owlpch.h"
#include <owl/editfile.h>
#include "resource.h"

#define CM_LANG_CHS 3000
#define CM_LANG_CHT 3001
#define CM_LANG_CSY 3002
#define CM_LANG_DEU 3003
#define CM_LANG_ELL 3004
#define CM_LANG_ENU 3005
#define CM_LANG_ESP 3006
#define CM_LANG_FRA 3007
#define CM_LANG_HUN 3008
#define CM_LANG_ITA 3009
#define CM_LANG_JPN 3010
#define CM_LANG_KOR 3011
#define CM_LANG_PTG 3012
#define CM_LANG_RUS 3013
#define CM_LANG_SKY 3014

static TLangModule* langModulePtr = 0;
TLangModule* GetResModule()
{
	return langModulePtr;
}

//{{TApplication = TIntlDemoApp}}
class TIntlDemoApp : public TApplication {
  public:
    TIntlDemoApp() : TApplication("International API Demo") {}


  protected:
    void   InitMainWindow();
    void   CmFileNew();
    void   CmFileOpen();
		void	 SetLanguage(TLangId langId);

    void   CmSetLangCHS();
    void   CmSetLangCHT();
    void   CmSetLangCSY();
    void   CmSetLangDEU();
    void   CmSetLangELL();
    void   CmSetLangENU();
    void   CmSetLangESP();
    void   CmSetLangFRA();
    void   CmSetLangHUN();
    void   CmSetLangITA();
    void   CmSetLangJPN();
    void   CmSetLangKOR();
    void   CmSetLangPTG();
    void   CmSetLangRUS();
    void   CmSetLangSKY();


//{{TIntlDemoAppVIRTUAL_BEGIN}}
	public:
		virtual void PreProcessMenu(HMENU hMenubar);
		virtual void InitInstance();
//{{TIntlDemoAppVIRTUAL_END}}
  
	DECLARE_RESPONSE_TABLE(TIntlDemoApp);
};//{{TIntlDemoApp}}

DEFINE_RESPONSE_TABLE1(TIntlDemoApp, TApplication)
  EV_COMMAND(CM_FILENEW, CmFileNew),
	EV_COMMAND(CM_FILEOPEN, CmFileOpen),
	EV_COMMAND(CM_LANG_CHS, CmSetLangCHS),
  EV_COMMAND(CM_LANG_CHT, CmSetLangCHT),
	EV_COMMAND(CM_LANG_CSY, CmSetLangCSY),
	EV_COMMAND(CM_LANG_DEU, CmSetLangDEU),
  EV_COMMAND(CM_LANG_ELL, CmSetLangELL),
	EV_COMMAND(CM_LANG_ENU, CmSetLangENU),
	EV_COMMAND(CM_LANG_ESP, CmSetLangESP),
  EV_COMMAND(CM_LANG_FRA, CmSetLangFRA),
	EV_COMMAND(CM_LANG_HUN, CmSetLangHUN),
	EV_COMMAND(CM_LANG_ITA, CmSetLangITA),
  EV_COMMAND(CM_LANG_JPN, CmSetLangJPN),
	EV_COMMAND(CM_LANG_KOR, CmSetLangKOR),
	EV_COMMAND(CM_LANG_PTG, CmSetLangPTG),
  EV_COMMAND(CM_LANG_RUS, CmSetLangRUS),
	EV_COMMAND(CM_LANG_SKY, CmSetLangSKY),
END_RESPONSE_TABLE;

//-----------------------------------------------------------------------------
void TIntlDemoApp::InitInstance()
{	
	// Call base class function.
	TApplication::InitInstance();

	PreProcessMenu(GetMainWindow()->GetMenu());
	GetMainWindow()->DrawMenuBar();
}
//-----------------------------------------------------------------------------
//
// Construct the TIntlDemoApp's MainWindow's client of type TEditFile
//
void
TIntlDemoApp::InitMainWindow()
{
	TEditFile* editFile = new TEditFile;
  TFrameWindow* frame = new TFrameWindow(0, Name, editFile, false, *GetResModule());
  editFile->SetModule(frame->GetModule());
	editFile->ModifyExStyle(0,WS_EX_CLIENTEDGE);
  
	frame->AssignMenu(IDM_EDITFILE);
	frame->SetAcceleratorTable(IDA_EDITFILE);
  
	frame->SetIcon(frame->GetModule(), IDI_OWLAPP);
	frame->SetIconSm(frame->GetModule(), IDI_OWLAPP);
	
	SetMainWindow(frame);
}
//-----------------------------------------------------------------------------
void 
TIntlDemoApp::SetLanguage(TLangId langId) 
{
	SetLangId(langId);
	GetResModule()->SetLanguage(langId);
  TFrameWindow* frame = GetMainWindow();

	frame->SetModule(*GetResModule());
	frame->AssignMenu(IDM_EDITFILE);
	frame->SetAcceleratorTable(IDA_EDITFILE);
  
	frame->SetIcon(frame->GetModule(), IDI_OWLAPP);
	frame->SetIconSm(frame->GetModule(), IDI_OWLAPP);
	frame->DrawMenuBar();
}
//-----------------------------------------------------------------------------
void TIntlDemoApp::CmSetLangCHS()
{
	SetLanguage(MAKELANGID(LANG_CHINESE,SUBLANG_CHINESE_SIMPLIFIED));
}
//-----------------------------------------------------------------------------
void TIntlDemoApp::CmSetLangCHT()
{
	SetLanguage(MAKELANGID(LANG_CHINESE,SUBLANG_CHINESE_TRADITIONAL));
}
//-----------------------------------------------------------------------------
void TIntlDemoApp::CmSetLangCSY()
{
	SetLanguage(MAKELANGID(LANG_CZECH,SUBLANG_NEUTRAL));
}
//-----------------------------------------------------------------------------
void TIntlDemoApp::CmSetLangDEU()
{
	SetLanguage(MAKELANGID(LANG_GERMAN,SUBLANG_NEUTRAL));
}
//-----------------------------------------------------------------------------
void TIntlDemoApp::CmSetLangELL()
{
	SetLanguage(MAKELANGID(LANG_GREEK,SUBLANG_NEUTRAL));
}
//-----------------------------------------------------------------------------
void TIntlDemoApp::CmSetLangENU()
{
	SetLanguage(MAKELANGID(LANG_ENGLISH,SUBLANG_NEUTRAL));
}
//-----------------------------------------------------------------------------
void TIntlDemoApp::CmSetLangESP()
{
	SetLanguage(MAKELANGID(LANG_SPANISH,SUBLANG_NEUTRAL));
}
//-----------------------------------------------------------------------------
void TIntlDemoApp::CmSetLangFRA()
{
	SetLanguage(MAKELANGID(LANG_FRENCH,SUBLANG_NEUTRAL));
}
//-----------------------------------------------------------------------------
void TIntlDemoApp::CmSetLangHUN()
{
	SetLanguage(MAKELANGID(LANG_HUNGARIAN,SUBLANG_NEUTRAL));
}
//-----------------------------------------------------------------------------
void TIntlDemoApp::CmSetLangITA()
{
	SetLanguage(MAKELANGID(LANG_ITALIAN,SUBLANG_NEUTRAL));
}
//-----------------------------------------------------------------------------
void TIntlDemoApp::CmSetLangJPN()
{
	SetLanguage(MAKELANGID(LANG_JAPANESE,SUBLANG_NEUTRAL));
}
//-----------------------------------------------------------------------------
void TIntlDemoApp::CmSetLangKOR()
{
	SetLanguage(MAKELANGID(LANG_KOREAN,SUBLANG_NEUTRAL));
}
//-----------------------------------------------------------------------------
void TIntlDemoApp::CmSetLangPTG()
{
	SetLanguage(MAKELANGID(LANG_PORTUGUESE,SUBLANG_NEUTRAL));
}
//-----------------------------------------------------------------------------
void TIntlDemoApp::CmSetLangRUS()
{
	SetLanguage(MAKELANGID(LANG_RUSSIAN,SUBLANG_NEUTRAL));
}
//-----------------------------------------------------------------------------
void TIntlDemoApp::CmSetLangSKY()
{
	SetLanguage(MAKELANGID(LANG_SLOVAK,SUBLANG_NEUTRAL));
}
//-----------------------------------------------------------------------------
	void TIntlDemoApp::PreProcessMenu(HMENU hMenubar)
{	
	// Call base class function.
	TApplication::PreProcessMenu(hMenubar);
  
  TMenu menubar(hMenubar);
  TPopupMenu intlPopup;
	intlPopup.AppendMenu(MF_STRING, CM_LANG_CHS, "Chinese Simplified");
	intlPopup.AppendMenu(MF_STRING, CM_LANG_CHT, "Chinese Traditional");
	intlPopup.AppendMenu(MF_STRING, CM_LANG_CSY, "Czech");
	intlPopup.AppendMenu(MF_STRING, CM_LANG_DEU, "German (Standard)");
	intlPopup.AppendMenu(MF_STRING, CM_LANG_ELL, "Greek");
	intlPopup.AppendMenu(MF_STRING, CM_LANG_ENU, "English (American)");
	intlPopup.AppendMenu(MF_STRING, CM_LANG_ESP, "Spanish (Standard/Traditional)");
	intlPopup.AppendMenu(MF_STRING, CM_LANG_FRA, "French (Standard)");
	intlPopup.AppendMenu(MF_STRING, CM_LANG_HUN, "Hungarian");
	intlPopup.AppendMenu(MF_STRING, CM_LANG_ITA, "Italian (Standard)");
	intlPopup.AppendMenu(MF_STRING, CM_LANG_JPN, "Japanese");
	intlPopup.AppendMenu(MF_STRING, CM_LANG_KOR, "Korean");
	intlPopup.AppendMenu(MF_STRING, CM_LANG_PTG, "Portuguese (Standard)");
	intlPopup.AppendMenu(MF_STRING, CM_LANG_RUS, "Russian");
	intlPopup.AppendMenu(MF_STRING, CM_LANG_SKY, "Slovak");
	//intlPopup.AppendMenu(MF_STRING, CM_LANG_, "");
	menubar.AppendMenu(MF_BYPOSITION|MF_POPUP, (uint)(HMENU)intlPopup, _T("Language"));
}
//-----------------------------------------------------------------------------
void
TIntlDemoApp::CmFileNew()
{
  TEditFile* ef = TYPESAFE_DOWNCAST(GetMainWindow()->GetClientWindow(), TEditFile);
  CHECK(ef);
  ef->NewFile();
}
//-----------------------------------------------------------------------------
void
TIntlDemoApp::CmFileOpen()
{
  TEditFile* ef = TYPESAFE_DOWNCAST(GetMainWindow()->GetClientWindow(), TEditFile);
  CHECK(ef);
  ef->Open();
}
//-----------------------------------------------------------------------------
int
OwlMain(int /*argc*/, _TCHAR* /*argv*/ [])
{
	TIntlDemoApp appl;
  TLangModule langModule(_T("owl_"), appl); // will be owl_###.dll
  langModulePtr = &langModule;
  return appl.Run();
}
//-----------------------------------------------------------------------------
